/*
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.
 */
var app = {
	
	storage: window.localStorage,
	
    // Application Constructor
    initialize: function() {
        this.bindEvents();
        $.datepicker.setDefaults($.datepicker.regional['it']);
        $( "#dataManutenzione, #txtSchedaData" ).date({ dateFormat: "dd/mm/yy" });
    },
    // Bind Event Listeners
    
    bindEvents: function() {
        document.addEventListener('deviceready', this.onDeviceReady, false);
        
       	
       	
        // lista elementi Hp Manutenzione
        $(function() {
        	analytics.startTrackerWithId('UA-50621575-1');
        	schedaManutenzione.createList();
        	schedaCarburante.createList();
        	 // alert($(".data").length);
        	// var d = $.Deferred();
			  // setTimeout(function() {
			    // d.resolve();
			  // }, 1000);
        	// alert($(".data").length);
        	// if ($(".data").length === 0 )   {
        		// $("#btnadd").addClass("ui-disabled");
        	// } else {
        		// $("#btnadd").removeClass("ui-disabled");
        	// }
        	
        });
		 
        //aggiorna la home per i contenuti ogni volta che ci arrivo
        $( "#HomePage" ).on( "pagebeforeshow", function( event ) { 
        	schedaManutenzione.createList();
		});
		
		$( "#ElencoSchedaCarburante" ).on( "pagebeforeshow", function( event ) { 
        	schedaCarburante.createList();
        	$("#btnadd").addClass("ui-disabled");
		});

        $("#btnadd").on("tap", function(){
        	homePage.statistics();
        	navigator.notification.confirm(
			             
			            "Vuoi andare alla pagina delle statistiche?",
			  
			            function(buttonIndex) {
			                if (buttonIndex == 1) {
			                    $.mobile.navigate( "#HomePage", { transition : "none" });
			                }
			            },
			  
			            "Statistiche generate",
			  
			            "Sì,No");
        });
		
        $(".btnExitApp").on("tap", function(){
			app.exit();
        });
        
        
        // ------------------------- ELENCO MANUTENZIONI DEL VEICOLO
        
        $("#btnSalvaManutenzione").on("tap", function(){
        	if ($("#titoloManutenzione").val() === "" || $("#dataManutenzione").val() === "" ) {
        		navigator.notification.alert(
					"Compilta tutti i campi!",
					function(){},
					"Attenzione",
					"OK"
				);
        	} else {
				schedaManutenzione.dati.tipo = $("#titoloManutenzione").val();
				schedaManutenzione.dati.data = $("#dataManutenzione").val();
				
				schedaManutenzione.save();
				
				navigator.notification.alert("Salvataggio effettuato!", function() {
					schedaManutenzione.calendar();
				}, "Salva");
			};
			
        });
        
		// ------------------------- SCHEDE DEL CARBURANTE
		
		$("#btnSalvaScheda").on("tap", function(){
			if ($("#txtSchedaData").val() === "" || $("#txtSchedaImporto").val() === "" || $("#txtSchedaLitri").val() === "" || $("#txtSchedaChilometri").val() === "" ){
				navigator.notification.alert(
					"Compilta tutti i campi!",
					function(){},
					"Attenzione",
					"OK"
				);
			} else {
				schedaCarburante.insert();
				
				navigator.notification.alert("Salvataggio effettuato!", function() {}, "Salva");
				
			};
			
		});

		 $("#txtSchedaLitri").on("tap", function(){
		 	schedaCarburante.calculateCost();
		 });
		
		// ------------------------- VISUALIZZAZIONE SCHEDE CARBURANTE
		
		$("#btnDropDb").on("tap", function(){
			navigator.notification.confirm(
			             
			            "Vuoi davvero eliminare tutti i rifornimenti?",
			  
			            function(buttonIndex) {
			                if (buttonIndex == 1) {
			                    schedaCarburante.dropDB();
							    location.reload();
			                    $("#btnadd").addClass("ui-disabled");
			                }
			            },
			  
			            "Elimina",
			  
			            "Sì,No");
			    });
		// $("#createArray").on("tap", function(){
			// schedaCarburante.groupList();
		// });  
    },
    
    // deviceready Event Handler
    onDeviceReady: function() {
    	//add eventListener
        app.receivedEvent('deviceready');
  		navigator.splashscreen.show();

    },
    
    exit: function(){
    	navigator.notification.confirm(
    		"Vuoi uscire dall'applicazione?",
    			function(buttonIndex) {
    				if (buttonIndex == 1) navigator.app.exitApp();
    			},
    		"Esci",
    		"Sì, No");
    },
    
};

var homePage = {
	
	statistics: function() {
		
			var sum = 0,
		 		sumEuro = 0,
		 		sumLitri = 0;
		 	
		 	$(".km").each(function(){
		 		sum += Number($(this).text());
		 	});
		 	 $(".currentCountKm").html(sum + " km");
		 	 
		 	 
		 	 $(".euro").each(function(){
		 		sumEuro += Number($(this).text());
		 	});
		 	 $(".currentCountEuro").html(sumEuro + " €");
		 	 
		 	 $(".litri").each(function(){
		 		sumLitri += Number($(this).text());
		 	});
		 	 $(".currentCountLitri").html(sumLitri + " l");
		 	 
		 	 var kmLitro = Math.round(sum / sumLitri *100)/100;
		 	 $(".currentCountKmL").html(kmLitro + " Km/l");

		 	 var LitriCentoKm = Math.round(100 / kmLitro *100)/100;
		 	 $(".currentCountLcKm").html(LitriCentoKm + " l/100km");
		 	 
		 	  var costoAlChilometro = Math.round(sumEuro / sum *100)/100;
		 	  $(".currentCountEK").html(costoAlChilometro + " €/Km");
		 	 
		 	  $(".dataHP").html("dal " + $("#1 .data").html());
		 	  
	}
};

var schedaManutenzione = {
	
	save: function() {
		if (schedaManutenzione.dati.tipo != "") {
			app.storage.setItem(schedaManutenzione.dati.tipo, JSON.stringify(schedaManutenzione.dati));
			}
	},
	
	calendar: function(){
		
		 	var d = $("#dataManutenzione").val().split('/'),
			 	startDate = new Date(Number(d[2]),Number(d[1]) -1 ,Number(d[0]),8,30,0,0,0),
				endDate = new Date(Number(d[2]),Number(d[1]) -1 ,Number(d[0]),9,30,0,0,0),
				location = "",
				title = schedaManutenzione.dati.tipo,
				notes = "",
				success = function(message) { navigator.notification.alert("Evento aggiunto al calendario!", function() {
					$("#titoloManutenzione").val('');
					$("#dataManutenzione").val('');
				}, "Salva"); },
				error = function(message) { alert("Errore: " + message); };
  
  			window.plugins.calendar.createEventInteractively(title,location,notes,startDate,endDate,success,error);
  			
	},
	
	dati: {tipo: "", data: ""},
	
	createList: function(event) { 
        	
           	var elencoManutenzioni = $("#liElencoManutenzioni");
        	$('#liElencoManutenzioni li').not('li:first').remove();
        	
        	for (var i=0; i<app.storage.length; i++) {
        		var key = localStorage.key(i),
	    			value = localStorage[key],
	    			getData = JSON.parse(value),
	    			li = $('<li class="ui-body-inherit ui-first-child ui-last-child ui-nodisc-icon" data-icon="arrow-l"><a href="#" key="'+key+'" class="del"><h2>' + key + '</h2><p>' + getData.data + '</p>' + '</a></li>');
        		
        		$("#counterManutenzione").html(i + 1);
        		
        		// eliminazione elementi
        		
        		li.on("swipeleft", ".del", function() {
        			   
			 	var key = $(this).attr('key');
			     
			    navigator.notification.confirm(
			             
			            "Confermi l'eliminazione della scheda?",
			  
			            function(buttonIndex) {
			                if (buttonIndex == 1) {
			                    $(li).closest('li').remove();
				    			
				  				localStorage.removeItem(key);
							    location.reload();
			                    
			                }
			            },
			  
			            "Elimina",
			  
			            "Sì,No");
			          
			    });
        		
        		elencoManutenzioni.append(li);
        		
        	}

			$("#liElencoManutenzioni").listview('refresh');
			schedaManutenzione.emptyList();
        },
        
        emptyList: function(){
        	if ($('#liElencoManutenzioni li').length == 1) {
				var emptyLi = $('<li class="ui-li-static ui-body-inherit ui-first-child ui-last-child"><h2>Non hai eventi in programma</h2><p>Clicca sulla scheda manutenzione per aggiungerlo</p></li>');
        		$("#liElencoManutenzioni").append(emptyLi);
        		$("#counterManutenzione").html(0);
        	}
        }
};

var db = openDatabase ("schedeCarburante", "1.0", "Schede del carburante", 25*1024*1024);

var schedaCarburante = {
	
	insert: function() {db.transaction(function (tx) {  
		   tx.executeSql('CREATE TABLE IF NOT EXISTS schede (id INTEGER NOT NULL PRIMARY KEY, data, importo, litri, chilometri INTEGER, euroLitro)');
		   tx.executeSql('INSERT INTO schede (data, importo, litri, chilometri, euroLitro) VALUES (?,?,?,?,?)' ,
			   [$('#txtSchedaData').val(), 
			  	$('#txtSchedaImporto').val(), 
			  	$('#txtSchedaLitri').val(), 
			  	$('#txtSchedaChilometri').val(), 
			  	$('#CostoCarburante').val()]);
		   
		  	$("#txtSchedaData").val('');
			$("#txtSchedaImporto").val('');
			$("#txtSchedaLitri").val('');
			$("#txtSchedaChilometri").val('');
			$("#CostoCarburante").val('');
			
		});
		
	},
	
	dropDB: function() {db.transaction(function (tx) {  
		   tx.executeSql('DROP TABLE schede');
		});
		
	},
	
	createList: function() {
		 
		var elencoSchede = $("#trSchede");
        	elencoSchede.html("");
        	schedaCarburante.emptyList();
        	 db.transaction(function(tx) {
			   tx.executeSql('SELECT * FROM schede;', [],
			     function(tx, result) {
			      if (result != null && result.rows != null) {
			        for (var i = 0; i < result.rows.length; i++) {
				          var row = result.rows.item(i);
				          elencoSchede.append('<tr id="' + row.id +'"><th class="data">' + row.data + '</th><td class="euro">' + row.importo + '</td><td class="litri">' + row.litri + '</td><td class="km"> '+ row.chilometri + '</td>' + '</tr>');
			        $("#table-custom-2").table( "refresh" );
			        schedaCarburante.emptyList();
				       	if ($(".data").length != 0 )   {
	        				$("#btnadd").removeClass("ui-disabled"); 
	        			}
			  		}
			        
			      }
			      
			     });
			 });
			 
			 return;
	},
	
	emptyList: function() {
		// var rowCount = $('#trSchede tr').length;
		// alert(rowCount);
		var emptyRow = $('<tr id="remove"><th>Nessuna scheda</th><td class="euro ui-table-priority-1">Nessuna scheda</td><td class="litri ui-table-priority-1">Nessuna scheda</td><td class="km ui-table-priority-2">Nessuna scheda</td></tr>');
		if ( $("#trSchede").find("tr").length === 0 ) {
				$('#table-custom-2').append(emptyRow);
				$("#table-custom-2").table( "refresh" );
			} else {
				$("#remove").remove();
		};
		
		
	 },
	
		 
	// groupList: function() {
		// arr = $('.data').map(function(){ 
				// return $(this).text(); }).get();
			// for (i=0; i<arr.length; i++) {
				// alert(arr[i]);
			// } 
	// },
		
	calculateCost: function() {
			var e = parseFloat($("#txtSchedaImporto").val()),
				c = parseFloat($("#CostoCarburante").val()),
				ec = e / c,
				result = Math.round(ec*1000)/1000 ;
		if (isNaN(result)) {
			navigator.notification.alert("Compila Importo e Costo!", function() {}, "Attenzione");	
		} else if (c === 0 || e === 0) {
			navigator.notification.alert("Inserisci valori diversi da zero!", function() {}, "Attenzione");	
		} else {
			$("#txtSchedaLitri").val(result);
		};
	},
	
	
	
};

$(document).ready(function() {
    app.initialize();

    $(document).bind("mobileinit", function(){
    $.mobile.defaultDialogTransition = "none";
    $.mobile.defaultPageTransition = "none";
	});
	
	$(document).on('pagebeforeshow', function(){     
	    var interval = setInterval(function(){
	        $.mobile.loading('show');
	        clearInterval(interval);
	    },1); 
	});
	
	$(document).on('pageshow', function(){  
	    var interval = setInterval(function(){
	        $.mobile.loading('hide');
	        clearInterval(interval);
	    },1);      
	    
	});

});